//-----------------------------------------------------------------------------
// Projet               : La physique amusante
// Classe               : Mobile.pde
// Auteur               : Sylvain Blocquaux
// Date                 : 11 avril 2011
// Version              : 1.0
//-----------------------------------------------------------------------------

class Mobile {
  PVector position;
  PVector positionPrec;
  PVector selectionRef;
  color couleur = color(255);
  boolean selection = false;
  PVector force = new PVector(0, 0);
  float masse = 0.5; // Masse en kg

  Mobile (PVector pos) {
    position = pos;
    positionPrec = pos;
  }

  void afficher() {
    fill(couleur);
    rect(position.x, position.y - 25, 50, 50);
  }

  void actualiser(float deltaT) {
    PVector calcul = PVector.mult(position, 2);  // Intégration Verlet x(t+1) = 2 * x(t) - x(t-1) + a * ∆T * ∆T
    calcul.sub(positionPrec);
    PVector acceleration = PVector.div(force, masse); // Loi de Newton : F = M * A
    acceleration.mult(deltaT * deltaT);
    calcul.add(acceleration);
    positionPrec = position.get();
    position = calcul.get();
    if (position.x < 70) {
      position.x = 70; // Limite minimale de compression du ressort
    }
  }

  void selectionner(PVector PMouse) {
    if ((PMouse.x > deplacement + position.x) && (PMouse.x < deplacement + position.x + 50) && (PMouse.y > deplacement + position.y - 25) && (PMouse.y < deplacement + position.y + 25)) {
      selection = true;
      selectionRef = PVector.sub(position, PMouse);
      couleur = color(100);
    }
  }

  void glisser(PVector PMouse) {
    if (selection) {
      position = PVector.add(selectionRef, PMouse);
      if (position.x  < 70) { // limite de compression du ressort
        position.x = 70;
      }
      position.y = -25; // impose le déplacement sur l'axe des X
    }
  }

  void deSelectionner() {
    selection = false;
    couleur = color(255);
  }
}

