//-----------------------------------------------------------------------------
// Projet               : La physique amusante
// Classe               : Ressort.pde
// Auteur               : Sylvain Blocquaux
// Date                 : 11 avril 2011
// Version              : 1.0
//-----------------------------------------------------------------------------

class Ressort {
  PVector pointAncre;
  Mobile pointMobile;
  float longueurRepos = 200; // longueur au repos en pixel
  float forceK = 5; // Constant de raideur en N.m-1
  int correction = 60; 

  Ressort(PVector pointA, Mobile pointB) {
    pointAncre = pointA;
    pointMobile = pointB;
  }

  void calculForce() {
    PVector rappel = PVector.sub(pointMobile.position, pointAncre); // Vecteur du déplacement
    float longueur = rappel.mag();
    float etirement = longueur - longueurRepos; // Calcul de l'étirement
    rappel.normalize();
    rappel.mult((-1) * forceK * etirement / correction); // Calcul de la force de rappel
    pointMobile.force = rappel;
  }

  void afficher() {
    float intervalle = (pointMobile.position.x - pointAncre.x) / 10;
    for (int i = 0; i < 10; i++) { // 10 spires de ressort
      noFill();
      beginShape();
      vertex(pointAncre.x + intervalle * i, -25);
      vertex(pointAncre.x + intervalle * i + intervalle / 4, -35);
      vertex(pointAncre.x + intervalle * i + 3 * intervalle / 4, -15);
      vertex(pointAncre.x + intervalle * i + intervalle, -25);
      endShape();
    }
  }
}

